package org.dromara.zhishu.service;

import jakarta.validation.constraints.NotNull;
import lombok.Data;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.zhishu.domain.Task;
import org.dromara.zhishu.domain.bo.*;
import org.dromara.zhishu.domain.dto.BookBaseInfoDto;
import org.dromara.zhishu.domain.excel.BaseInfoExcel;
import org.dromara.zhishu.domain.vo.BaseInfoPricingVo;
import org.dromara.zhishu.domain.vo.BookBaseInfoVo;
import org.dromara.zhishu.domain.vo.TaskUrlVo;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 基础信息Service接口
 *
 * @author Lion Li
 * @date 2025-03-08
 */
public interface IBookBaseInfoService {

    /**
     * 查询基础信息
     *
     * @param id 主键
     * @return 基础信息
     */
    BookBaseInfoVo queryById(String id);


    /**
     * 分页查询基础信息列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 基础信息分页列表
     */
    TableDataInfo<BookBaseInfoVo> queryPageList(BookBaseInfoDto bo, BookNumberRageBo number, PageQuery pageQuery);

    /**
     * 查询符合条件的基础信息列表
     *
     * @param bo 查询条件
     * @return 基础信息列表
     */
    List<BookBaseInfoVo> queryList(BookBaseInfoBo bo);

    /**
     * 新增基础信息
     *
     * @param bo 基础信息
     * @return 是否新增成功
     */
    Boolean insertByBo(BookBaseInfoBo bo);

    /**
     * 修改基础信息
     *
     * @param bo 基础信息
     * @return 是否修改成功
     */
    Boolean updateByBo(EditBookInfoBo bo);

    Boolean updateByIsbn(BookBaseInfoBo bo);

    /**
     * 校验并批量删除基础信息信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<String> ids, Boolean isValid);
    /**
     * 校验并批量删除基础信息信息
     *

     * @return 是否删除成功
     */
    void importExcel( List<BaseInfoExcel> list);

    /**
     * 校验并批量删除基础信息信息
     *

     * @return 是否删除成功
     */
    Map<String, Object> getList( );

    BookBaseInfoVo getIsbnInfo(String isbn);

    BookBaseInfoVo getIsbnList(String isbn);

    List<BookBaseInfoVo> getBookListByBookName(String bookName);

    List<BookBaseInfoVo> selectBookPicList();

    List<BookBaseInfoVo> queryBookPicList(BookBaseInfoBo bo);

    String getpamp(BookBaseInfoBo bo, BookNumberRageBo number, BookBaseInfoDto dto, String page, String per_page);

    int delectByIsbn(String isbn);

    int updateByIllge(IllBaseInfoBo bo);

    TableDataInfo<BaseInfoPricingVo> queryPagePricingList(BookBaseInfoDto bo, BookNumberRageBo number, PageQuery pageQuery);

    String pricingLink(BookBaseInfoBo bo, PageQuery pageQuery);

    Map pricingLinkDec(String link);

    Boolean getUserVip(Integer type);

    Map insertTask(TaskBo bo);

    int addNewTask(Task task);

    Map setBalance();

    void insertUserInfo(UserRechargeBo bo,String title,Integer payType,Integer price);

    Map getImageDite(Long isbn);

    BookBaseInfoVo getBookByIsbn(@NotNull(message = "主键不能为空") String isbn);

    BookBaseInfoVo getBookData(@NotNull(message = "主键不能为空") String isbn);

    TableDataInfo<BookBaseInfoVo> getBookDataByIsbn(String isbn);

    Boolean updateCentBookByIsbn(BookUpdateInfoBo bo);
}
